// test2.cpp--test Idrapp progress reporting

#include <windows.h>
#include <iostream.h>
#include "idrapp.h"

Idrapp i;

void main() {

   ProgStruct Prog, Prog2;
   short result, ClientId, ProcId;
   short PtHinst = 0;
   short result2, ClientId2, StatId;
   short show = SHOW_IDRISI_MINIMIZED;
   short mon;
   float calc;

   char *dir = "c:\\0home\\test\\idr_vc\\";
   char *module = "project";
   char *opt = "1 westboro spc27ma1 testwb us27tm19 279078 290565.3 4678095 4686651 614 486 0 1";
   char *title = "";
   char *units = "";
   bool MFI = false;

   if (MFI)
      mon = MONITOR_FROM_IDRISI;
   else
      mon = MONITOR_FROM_CLIENT_ONLY;

   if (! i.IsIdrisiPresent())
      result = i.LaunchIdrisi(show);
   i.SetDataDirectory(dir);

   ClientId = i.RegisterClient();
   ProcId = i.LaunchModule(ClientId, mon, module, opt, title, units, &PtHinst);
   if (! MFI)
   {
      ClientId2 = i.RegisterClient();
      StatId = i.InitProgressTracking(ClientId2, module);
   }
   do
   {
      result = i.GetProgress(ClientId, ProcId, &Prog);
      if (Prog.Status == PROCSTATUS_ERROR_TERMINATE)
      {
         cout << "Error executing module.\n";
         break;
      }
      if (! MFI)
      {
         Prog2.Status = Prog.Status;
         Prog2.ReportType = Prog.ReportType;
         switch (Prog.ReportType)
         {
            case REPORT_TYPE_WORKING:
               Prog2.PassNum = 1;
               Prog2.TotalPasses = 1;
               Prog2.PercentDone = 0.0;
               break;
            case REPORT_TYPE_PERCENTDONE:
               Prog2.PassNum = 1;
               Prog2.TotalPasses = 1;
               Prog2.PercentDone = Prog.PercentDone / 100;
               if (Prog2.PercentDone < 0.0) Prog2.PercentDone = 0.0;
               if (Prog2.PercentDone > 1.0) Prog2.PercentDone = 1.0;
               break;
            case REPORT_TYPE_PASS_X_OF_N:
               Prog2.PassNum = Prog.PassNum;
               if (Prog2.PassNum < 0) Prog2.PassNum = 0;
               Prog2.TotalPasses = Prog.TotalPasses;
               Prog2.PercentDone = 0.0;
               break;
            case REPORT_TYPE_PASS_TOTALUNKNOWN:
               Prog2.PassNum = Prog.PassNum;
               if (Prog2.PassNum < 0) Prog2.PassNum = 0;
               Prog2.TotalPasses = 0;
               Prog2.PercentDone = 0.0;
               break;
            case REPORT_TYPE_COMPLEXPASS:
               calc = (float)(Prog.PassNum - 2080) / 100;
               Prog2.PassNum = (short) calc + 1;
               Prog2.TotalPasses = Prog.TotalPasses;
               if (Prog2.PassNum > Prog2.TotalPasses)
                  Prog2.PassNum = Prog2.TotalPasses;
               calc = -207900 - Prog.PercentDone;
               calc = calc - ((Prog2.PassNum - 1) * 9900);
               Prog2.PercentDone = calc / 99.0f;
               if (Prog2.PercentDone < 0.0) Prog2.PercentDone = 0.0;
               if (Prog2.PercentDone > 100.0) Prog2.PercentDone = 100.0;
               break;
         }
         result2 = i.SetProgress(ClientId2, StatId, &Prog2);
      }
   }
   while (Prog.Status == PROCSTATUS_ACTIVE);

   result = i.UnRegisterClient(ClientId);
   if (! MFI)
      result = i.UnRegisterClient(ClientId2);
   cout << "Done.\n";
   return;
}

